import { TracerInterface } from '.';
import { HandlerMethodDecorator, TracerOptions, MethodDecorator } from '../types';
import { ProviderServiceInterface } from './provider';
import { Segment, Subsegment } from 'aws-xray-sdk-core';
declare class Tracer implements TracerInterface {
    static coldStart: boolean;
    provider: ProviderServiceInterface;
    private captureError;
    private captureResponse;
    private customConfigService?;
    private envVarsService?;
    private serviceName;
    private tracingEnabled;
    constructor(options?: TracerOptions);
    captureAWS<T>(aws: T): T;
    captureAWSClient<T>(service: T): T;
    captureAWSv3Client<T>(service: T): T;
    captureLambdaHanlder(): HandlerMethodDecorator;
    captureMethod(): MethodDecorator;
    getSegment(): Segment | Subsegment;
    static isColdStart(): boolean;
    putAnnotation(key: string, value: string | number | boolean): void;
    putMetadata(key: string, value: unknown, namespace?: string | undefined): void;
    setSegment(segment: Segment | Subsegment): void;
    private addErrorAsMetadata;
    private addResponseAsMetadata;
    private annotateColdStart;
    private getCustomConfigService;
    private getEnvVarsService;
    private isLambdaExecutionEnv;
    private isLambdaSamCli;
    private isValidServiceName;
    private setCaptureError;
    private setCaptureResponse;
    private setCustomConfigService;
    private setEnvVarsService;
    private setOptions;
    private setServiceName;
    private setTracingEnabled;
}
export { Tracer };
//# sourceMappingURL=Tracer.d.ts.map